<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfConsumptionReportItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfConsumptionReportItem extends AbstractStructArrayBase
{
    /**
     * The ConsumptionReportItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ConsumptionReportItem[]
     */
    public $ConsumptionReportItem;
    /**
     * Constructor method for ArrayOfConsumptionReportItem
     * @uses ArrayOfConsumptionReportItem::setConsumptionReportItem()
     * @param \StructType\ConsumptionReportItem[] $consumptionReportItem
     */
    public function __construct(array $consumptionReportItem = array())
    {
        $this
            ->setConsumptionReportItem($consumptionReportItem);
    }
    /**
     * Get ConsumptionReportItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ConsumptionReportItem[]|null
     */
    public function getConsumptionReportItem()
    {
        return isset($this->ConsumptionReportItem) ? $this->ConsumptionReportItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setConsumptionReportItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setConsumptionReportItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateConsumptionReportItemForArrayConstraintsFromSetConsumptionReportItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfConsumptionReportItemConsumptionReportItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfConsumptionReportItemConsumptionReportItemItem instanceof \StructType\ConsumptionReportItem) {
                $invalidValues[] = is_object($arrayOfConsumptionReportItemConsumptionReportItemItem) ? get_class($arrayOfConsumptionReportItemConsumptionReportItemItem) : sprintf('%s(%s)', gettype($arrayOfConsumptionReportItemConsumptionReportItemItem), var_export($arrayOfConsumptionReportItemConsumptionReportItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ConsumptionReportItem property can only contain items of type \StructType\ConsumptionReportItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ConsumptionReportItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ConsumptionReportItem[] $consumptionReportItem
     * @return \ArrayType\ArrayOfConsumptionReportItem
     */
    public function setConsumptionReportItem(array $consumptionReportItem = array())
    {
        // validation for constraint: array
        if ('' !== ($consumptionReportItemArrayErrorMessage = self::validateConsumptionReportItemForArrayConstraintsFromSetConsumptionReportItem($consumptionReportItem))) {
            throw new \InvalidArgumentException($consumptionReportItemArrayErrorMessage, __LINE__);
        }
        if (is_null($consumptionReportItem) || (is_array($consumptionReportItem) && empty($consumptionReportItem))) {
            unset($this->ConsumptionReportItem);
        } else {
            $this->ConsumptionReportItem = $consumptionReportItem;
        }
        return $this;
    }
    /**
     * Add item to ConsumptionReportItem value
     * @throws \InvalidArgumentException
     * @param \StructType\ConsumptionReportItem $item
     * @return \ArrayType\ArrayOfConsumptionReportItem
     */
    public function addToConsumptionReportItem(\StructType\ConsumptionReportItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ConsumptionReportItem) {
            throw new \InvalidArgumentException(sprintf('The ConsumptionReportItem property can only contain items of type \StructType\ConsumptionReportItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ConsumptionReportItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ConsumptionReportItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ConsumptionReportItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ConsumptionReportItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ConsumptionReportItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ConsumptionReportItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ConsumptionReportItem
     */
    public function getAttributeName()
    {
        return 'ConsumptionReportItem';
    }
}
